#! /bin/sh
PWD=$(pwd)
FW=$1
FW=${FW:=AQC111-3.1.106.clx}
AQC_UPDATE_FW_VERSION=3.1.106

chmod a+x $PWD/listDevices
chmod a+x $PWD/readstat
chmod a+x $PWD/flashErase
chmod a+x $PWD/flashBurn
chmod a+x $PWD/flashOverride

vercomp () {
    if [[ $1 == $2 ]]
    then
        return 0
    fi
    local IFS=.
    local i ver1=($1) ver2=($2)
    # fill empty fields in ver1 with zeros
    for ((i=${#ver1[@]}; i<${#ver2[@]}; i++))
    do
        ver1[i]=0
    done
    for ((i=0; i<${#ver1[@]}; i++))
    do
        if [[ -z ${ver2[i]} ]]
        then
            # fill empty fields in ver2 with zeros
            ver2[i]=0
        fi
        if ((10#${ver1[i]} > 10#${ver2[i]}))
        then
            return 1
        fi
        if ((10#${ver1[i]} < 10#${ver2[i]}))
        then
            return 2
        fi
    done
    return 0
}

Gen_conf()
{
  echo Set Conf...

  for device in $($PWD/listDevices | grep -v 'listDevices\|PCI'| grep -)
  do
    sub_device_id=$($PWD/readstat -d ${device##*-} | grep "Subsystem Device ID")
    fw_ver=$($PWD/readstat -d ${device##*-} | grep "Firmware Version" | grep -v PHY)
    #vercomp ${AQC_UPDATE_FW_VERSION} ${fw_ver##*=}
    #if [ $? != 1 ] || [ ${sub_device_id##*=} != "0x87B3" ]; then
    if [ ${sub_device_id##*=} != "0x87B3" ]; then
      echo $device pass...
      continue
    fi
    mac_address=$($PWD/readstat -d ${device##*-} | grep "MAC address" | grep -v eFuse)

    if [ -f $PWD/$device ]; then
        /bin/rm $PWD/$device
    fi
    touch $PWD/$device
    /sbin/setcfg "$device" "MAC address" "${mac_address##*=}" -f $PWD/$device
  done
}

Erase_and_Burn()
{
  echo Erase_and_Burn...
  for device in $($PWD/listDevices | grep -v 'listDevices\|PCI' | grep -)
  do
    if [ -f "$PWD/$device" ]; then
      echo Device $device update
      $PWD/flashErase -d $device
      $PWD/flashBurn -d $device $PWD/$FW

      local mac=$(/sbin/getcfg "$device" "MAC address" -f $PWD/$device)
      $PWD/flashOverride -d $device -m $mac 
      echo Device $device done
    fi
  done

  echo Update all QXG-5G1T-111C finished. Please cold reboot the system.
}

Gen_conf
Erase_and_Burn

